<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WBFlightManifestItemRS StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:WBFlightManifestItemRS
 * @subpackage Structs
 */
class WBFlightManifestItemRS extends AbstractStructBase
{
    /**
     * The ArrivalAirport
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ArrivalAirport;
    /**
     * The BoardDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BoardDate;
    /**
     * The DepartureAirport
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DepartureAirport;
    /**
     * The LegNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $LegNumber;
    /**
     * The ManifestInformation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoRS
     */
    public $ManifestInformation;
    /**
     * The MarketingCarrierCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MarketingCarrierCode;
    /**
     * The MarketingFlightNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MarketingFlightNumber;
    /**
     * The OperatingCarrierCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperatingCarrierCode;
    /**
     * The OperatingFlightNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperatingFlightNumber;
    /**
     * The Passengers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWBPassengerRS
     */
    public $Passengers;
    /**
     * Constructor method for WBFlightManifestItemRS
     * @uses WBFlightManifestItemRS::setArrivalAirport()
     * @uses WBFlightManifestItemRS::setBoardDate()
     * @uses WBFlightManifestItemRS::setDepartureAirport()
     * @uses WBFlightManifestItemRS::setLegNumber()
     * @uses WBFlightManifestItemRS::setManifestInformation()
     * @uses WBFlightManifestItemRS::setMarketingCarrierCode()
     * @uses WBFlightManifestItemRS::setMarketingFlightNumber()
     * @uses WBFlightManifestItemRS::setOperatingCarrierCode()
     * @uses WBFlightManifestItemRS::setOperatingFlightNumber()
     * @uses WBFlightManifestItemRS::setPassengers()
     * @param string $arrivalAirport
     * @param string $boardDate
     * @param string $departureAirport
     * @param int $legNumber
     * @param \StructType\WBManifestInfoRS $manifestInformation
     * @param string $marketingCarrierCode
     * @param string $marketingFlightNumber
     * @param string $operatingCarrierCode
     * @param string $operatingFlightNumber
     * @param \ArrayType\ArrayOfWBPassengerRS $passengers
     */
    public function __construct($arrivalAirport = null, $boardDate = null, $departureAirport = null, $legNumber = null, \StructType\WBManifestInfoRS $manifestInformation = null, $marketingCarrierCode = null, $marketingFlightNumber = null, $operatingCarrierCode = null, $operatingFlightNumber = null, \ArrayType\ArrayOfWBPassengerRS $passengers = null)
    {
        $this
            ->setArrivalAirport($arrivalAirport)
            ->setBoardDate($boardDate)
            ->setDepartureAirport($departureAirport)
            ->setLegNumber($legNumber)
            ->setManifestInformation($manifestInformation)
            ->setMarketingCarrierCode($marketingCarrierCode)
            ->setMarketingFlightNumber($marketingFlightNumber)
            ->setOperatingCarrierCode($operatingCarrierCode)
            ->setOperatingFlightNumber($operatingFlightNumber)
            ->setPassengers($passengers);
    }
    /**
     * Get ArrivalAirport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getArrivalAirport()
    {
        return isset($this->ArrivalAirport) ? $this->ArrivalAirport : null;
    }
    /**
     * Set ArrivalAirport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $arrivalAirport
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setArrivalAirport($arrivalAirport = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalAirport) && !is_string($arrivalAirport)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($arrivalAirport)), __LINE__);
        }
        if (is_null($arrivalAirport) || (is_array($arrivalAirport) && empty($arrivalAirport))) {
            unset($this->ArrivalAirport);
        } else {
            $this->ArrivalAirport = $arrivalAirport;
        }
        return $this;
    }
    /**
     * Get BoardDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBoardDate()
    {
        return isset($this->BoardDate) ? $this->BoardDate : null;
    }
    /**
     * Set BoardDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $boardDate
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setBoardDate($boardDate = null)
    {
        // validation for constraint: string
        if (!is_null($boardDate) && !is_string($boardDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($boardDate)), __LINE__);
        }
        if (is_null($boardDate) || (is_array($boardDate) && empty($boardDate))) {
            unset($this->BoardDate);
        } else {
            $this->BoardDate = $boardDate;
        }
        return $this;
    }
    /**
     * Get DepartureAirport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDepartureAirport()
    {
        return isset($this->DepartureAirport) ? $this->DepartureAirport : null;
    }
    /**
     * Set DepartureAirport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $departureAirport
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setDepartureAirport($departureAirport = null)
    {
        // validation for constraint: string
        if (!is_null($departureAirport) && !is_string($departureAirport)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($departureAirport)), __LINE__);
        }
        if (is_null($departureAirport) || (is_array($departureAirport) && empty($departureAirport))) {
            unset($this->DepartureAirport);
        } else {
            $this->DepartureAirport = $departureAirport;
        }
        return $this;
    }
    /**
     * Get LegNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getLegNumber()
    {
        return isset($this->LegNumber) ? $this->LegNumber : null;
    }
    /**
     * Set LegNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $legNumber
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setLegNumber($legNumber = null)
    {
        // validation for constraint: int
        if (!is_null($legNumber) && !is_numeric($legNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($legNumber)), __LINE__);
        }
        if (is_null($legNumber) || (is_array($legNumber) && empty($legNumber))) {
            unset($this->LegNumber);
        } else {
            $this->LegNumber = $legNumber;
        }
        return $this;
    }
    /**
     * Get ManifestInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoRS|null
     */
    public function getManifestInformation()
    {
        return isset($this->ManifestInformation) ? $this->ManifestInformation : null;
    }
    /**
     * Set ManifestInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoRS $manifestInformation
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setManifestInformation(\StructType\WBManifestInfoRS $manifestInformation = null)
    {
        if (is_null($manifestInformation) || (is_array($manifestInformation) && empty($manifestInformation))) {
            unset($this->ManifestInformation);
        } else {
            $this->ManifestInformation = $manifestInformation;
        }
        return $this;
    }
    /**
     * Get MarketingCarrierCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMarketingCarrierCode()
    {
        return isset($this->MarketingCarrierCode) ? $this->MarketingCarrierCode : null;
    }
    /**
     * Set MarketingCarrierCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $marketingCarrierCode
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setMarketingCarrierCode($marketingCarrierCode = null)
    {
        // validation for constraint: string
        if (!is_null($marketingCarrierCode) && !is_string($marketingCarrierCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($marketingCarrierCode)), __LINE__);
        }
        if (is_null($marketingCarrierCode) || (is_array($marketingCarrierCode) && empty($marketingCarrierCode))) {
            unset($this->MarketingCarrierCode);
        } else {
            $this->MarketingCarrierCode = $marketingCarrierCode;
        }
        return $this;
    }
    /**
     * Get MarketingFlightNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMarketingFlightNumber()
    {
        return isset($this->MarketingFlightNumber) ? $this->MarketingFlightNumber : null;
    }
    /**
     * Set MarketingFlightNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $marketingFlightNumber
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setMarketingFlightNumber($marketingFlightNumber = null)
    {
        // validation for constraint: string
        if (!is_null($marketingFlightNumber) && !is_string($marketingFlightNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($marketingFlightNumber)), __LINE__);
        }
        if (is_null($marketingFlightNumber) || (is_array($marketingFlightNumber) && empty($marketingFlightNumber))) {
            unset($this->MarketingFlightNumber);
        } else {
            $this->MarketingFlightNumber = $marketingFlightNumber;
        }
        return $this;
    }
    /**
     * Get OperatingCarrierCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperatingCarrierCode()
    {
        return isset($this->OperatingCarrierCode) ? $this->OperatingCarrierCode : null;
    }
    /**
     * Set OperatingCarrierCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operatingCarrierCode
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setOperatingCarrierCode($operatingCarrierCode = null)
    {
        // validation for constraint: string
        if (!is_null($operatingCarrierCode) && !is_string($operatingCarrierCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($operatingCarrierCode)), __LINE__);
        }
        if (is_null($operatingCarrierCode) || (is_array($operatingCarrierCode) && empty($operatingCarrierCode))) {
            unset($this->OperatingCarrierCode);
        } else {
            $this->OperatingCarrierCode = $operatingCarrierCode;
        }
        return $this;
    }
    /**
     * Get OperatingFlightNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperatingFlightNumber()
    {
        return isset($this->OperatingFlightNumber) ? $this->OperatingFlightNumber : null;
    }
    /**
     * Set OperatingFlightNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operatingFlightNumber
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setOperatingFlightNumber($operatingFlightNumber = null)
    {
        // validation for constraint: string
        if (!is_null($operatingFlightNumber) && !is_string($operatingFlightNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($operatingFlightNumber)), __LINE__);
        }
        if (is_null($operatingFlightNumber) || (is_array($operatingFlightNumber) && empty($operatingFlightNumber))) {
            unset($this->OperatingFlightNumber);
        } else {
            $this->OperatingFlightNumber = $operatingFlightNumber;
        }
        return $this;
    }
    /**
     * Get Passengers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWBPassengerRS|null
     */
    public function getPassengers()
    {
        return isset($this->Passengers) ? $this->Passengers : null;
    }
    /**
     * Set Passengers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWBPassengerRS $passengers
     * @return \StructType\WBFlightManifestItemRS
     */
    public function setPassengers(\ArrayType\ArrayOfWBPassengerRS $passengers = null)
    {
        if (is_null($passengers) || (is_array($passengers) && empty($passengers))) {
            unset($this->Passengers);
        } else {
            $this->Passengers = $passengers;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WBFlightManifestItemRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
