<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WBManifestInfoPassengerCounts StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:WBManifestInfoPassengerCounts
 * @subpackage Structs
 */
class WBManifestInfoPassengerCounts extends AbstractStructBase
{
    /**
     * The Children
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Children;
    /**
     * The Females
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Females;
    /**
     * The Infants
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Infants;
    /**
     * The Males
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Males;
    /**
     * Constructor method for WBManifestInfoPassengerCounts
     * @uses WBManifestInfoPassengerCounts::setChildren()
     * @uses WBManifestInfoPassengerCounts::setFemales()
     * @uses WBManifestInfoPassengerCounts::setInfants()
     * @uses WBManifestInfoPassengerCounts::setMales()
     * @param int $children
     * @param int $females
     * @param int $infants
     * @param int $males
     */
    public function __construct($children = null, $females = null, $infants = null, $males = null)
    {
        $this
            ->setChildren($children)
            ->setFemales($females)
            ->setInfants($infants)
            ->setMales($males);
    }
    /**
     * Get Children value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getChildren()
    {
        return isset($this->Children) ? $this->Children : null;
    }
    /**
     * Set Children value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $children
     * @return \StructType\WBManifestInfoPassengerCounts
     */
    public function setChildren($children = null)
    {
        // validation for constraint: int
        if (!is_null($children) && !is_numeric($children)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($children)), __LINE__);
        }
        if (is_null($children) || (is_array($children) && empty($children))) {
            unset($this->Children);
        } else {
            $this->Children = $children;
        }
        return $this;
    }
    /**
     * Get Females value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getFemales()
    {
        return isset($this->Females) ? $this->Females : null;
    }
    /**
     * Set Females value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $females
     * @return \StructType\WBManifestInfoPassengerCounts
     */
    public function setFemales($females = null)
    {
        // validation for constraint: int
        if (!is_null($females) && !is_numeric($females)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($females)), __LINE__);
        }
        if (is_null($females) || (is_array($females) && empty($females))) {
            unset($this->Females);
        } else {
            $this->Females = $females;
        }
        return $this;
    }
    /**
     * Get Infants value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getInfants()
    {
        return isset($this->Infants) ? $this->Infants : null;
    }
    /**
     * Set Infants value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $infants
     * @return \StructType\WBManifestInfoPassengerCounts
     */
    public function setInfants($infants = null)
    {
        // validation for constraint: int
        if (!is_null($infants) && !is_numeric($infants)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($infants)), __LINE__);
        }
        if (is_null($infants) || (is_array($infants) && empty($infants))) {
            unset($this->Infants);
        } else {
            $this->Infants = $infants;
        }
        return $this;
    }
    /**
     * Get Males value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getMales()
    {
        return isset($this->Males) ? $this->Males : null;
    }
    /**
     * Set Males value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $males
     * @return \StructType\WBManifestInfoPassengerCounts
     */
    public function setMales($males = null)
    {
        // validation for constraint: int
        if (!is_null($males) && !is_numeric($males)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($males)), __LINE__);
        }
        if (is_null($males) || (is_array($males) && empty($males))) {
            unset($this->Males);
        } else {
            $this->Males = $males;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WBManifestInfoPassengerCounts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
