<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WBManifestInfoRS StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:WBManifestInfoRS
 * @subpackage Structs
 */
class WBManifestInfoRS extends AbstractStructBase
{
    /**
     * The FlightStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FlightStatus;
    /**
     * The NonRevPassengersBoarded
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoPassengerCounts
     */
    public $NonRevPassengersBoarded;
    /**
     * The NonRevPassengersBooked
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoPassengerCounts
     */
    public $NonRevPassengersBooked;
    /**
     * The NonRevPassengersCheckedIn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoPassengerCounts
     */
    public $NonRevPassengersCheckedIn;
    /**
     * The RevPassengersBoarded
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoPassengerCounts
     */
    public $RevPassengersBoarded;
    /**
     * The RevPassengersBooked
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoPassengerCounts
     */
    public $RevPassengersBooked;
    /**
     * The RevPassengersCheckedIn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WBManifestInfoPassengerCounts
     */
    public $RevPassengersCheckedIn;
    /**
     * The TotalBagCount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $TotalBagCount;
    /**
     * The TotalBagWeight
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $TotalBagWeight;
    /**
     * The TotalPassengersBoarded
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $TotalPassengersBoarded;
    /**
     * The TotalPassengersBooked
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $TotalPassengersBooked;
    /**
     * The TotalPassengersCheckedIn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $TotalPassengersCheckedIn;
    /**
     * The TotalSeatCapacity
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $TotalSeatCapacity;
    /**
     * Constructor method for WBManifestInfoRS
     * @uses WBManifestInfoRS::setFlightStatus()
     * @uses WBManifestInfoRS::setNonRevPassengersBoarded()
     * @uses WBManifestInfoRS::setNonRevPassengersBooked()
     * @uses WBManifestInfoRS::setNonRevPassengersCheckedIn()
     * @uses WBManifestInfoRS::setRevPassengersBoarded()
     * @uses WBManifestInfoRS::setRevPassengersBooked()
     * @uses WBManifestInfoRS::setRevPassengersCheckedIn()
     * @uses WBManifestInfoRS::setTotalBagCount()
     * @uses WBManifestInfoRS::setTotalBagWeight()
     * @uses WBManifestInfoRS::setTotalPassengersBoarded()
     * @uses WBManifestInfoRS::setTotalPassengersBooked()
     * @uses WBManifestInfoRS::setTotalPassengersCheckedIn()
     * @uses WBManifestInfoRS::setTotalSeatCapacity()
     * @param string $flightStatus
     * @param \StructType\WBManifestInfoPassengerCounts $nonRevPassengersBoarded
     * @param \StructType\WBManifestInfoPassengerCounts $nonRevPassengersBooked
     * @param \StructType\WBManifestInfoPassengerCounts $nonRevPassengersCheckedIn
     * @param \StructType\WBManifestInfoPassengerCounts $revPassengersBoarded
     * @param \StructType\WBManifestInfoPassengerCounts $revPassengersBooked
     * @param \StructType\WBManifestInfoPassengerCounts $revPassengersCheckedIn
     * @param int $totalBagCount
     * @param float $totalBagWeight
     * @param int $totalPassengersBoarded
     * @param int $totalPassengersBooked
     * @param int $totalPassengersCheckedIn
     * @param int $totalSeatCapacity
     */
    public function __construct($flightStatus = null, \StructType\WBManifestInfoPassengerCounts $nonRevPassengersBoarded = null, \StructType\WBManifestInfoPassengerCounts $nonRevPassengersBooked = null, \StructType\WBManifestInfoPassengerCounts $nonRevPassengersCheckedIn = null, \StructType\WBManifestInfoPassengerCounts $revPassengersBoarded = null, \StructType\WBManifestInfoPassengerCounts $revPassengersBooked = null, \StructType\WBManifestInfoPassengerCounts $revPassengersCheckedIn = null, $totalBagCount = null, $totalBagWeight = null, $totalPassengersBoarded = null, $totalPassengersBooked = null, $totalPassengersCheckedIn = null, $totalSeatCapacity = null)
    {
        $this
            ->setFlightStatus($flightStatus)
            ->setNonRevPassengersBoarded($nonRevPassengersBoarded)
            ->setNonRevPassengersBooked($nonRevPassengersBooked)
            ->setNonRevPassengersCheckedIn($nonRevPassengersCheckedIn)
            ->setRevPassengersBoarded($revPassengersBoarded)
            ->setRevPassengersBooked($revPassengersBooked)
            ->setRevPassengersCheckedIn($revPassengersCheckedIn)
            ->setTotalBagCount($totalBagCount)
            ->setTotalBagWeight($totalBagWeight)
            ->setTotalPassengersBoarded($totalPassengersBoarded)
            ->setTotalPassengersBooked($totalPassengersBooked)
            ->setTotalPassengersCheckedIn($totalPassengersCheckedIn)
            ->setTotalSeatCapacity($totalSeatCapacity);
    }
    /**
     * Get FlightStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFlightStatus()
    {
        return isset($this->FlightStatus) ? $this->FlightStatus : null;
    }
    /**
     * Set FlightStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $flightStatus
     * @return \StructType\WBManifestInfoRS
     */
    public function setFlightStatus($flightStatus = null)
    {
        // validation for constraint: string
        if (!is_null($flightStatus) && !is_string($flightStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($flightStatus)), __LINE__);
        }
        if (is_null($flightStatus) || (is_array($flightStatus) && empty($flightStatus))) {
            unset($this->FlightStatus);
        } else {
            $this->FlightStatus = $flightStatus;
        }
        return $this;
    }
    /**
     * Get NonRevPassengersBoarded value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoPassengerCounts|null
     */
    public function getNonRevPassengersBoarded()
    {
        return isset($this->NonRevPassengersBoarded) ? $this->NonRevPassengersBoarded : null;
    }
    /**
     * Set NonRevPassengersBoarded value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoPassengerCounts $nonRevPassengersBoarded
     * @return \StructType\WBManifestInfoRS
     */
    public function setNonRevPassengersBoarded(\StructType\WBManifestInfoPassengerCounts $nonRevPassengersBoarded = null)
    {
        if (is_null($nonRevPassengersBoarded) || (is_array($nonRevPassengersBoarded) && empty($nonRevPassengersBoarded))) {
            unset($this->NonRevPassengersBoarded);
        } else {
            $this->NonRevPassengersBoarded = $nonRevPassengersBoarded;
        }
        return $this;
    }
    /**
     * Get NonRevPassengersBooked value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoPassengerCounts|null
     */
    public function getNonRevPassengersBooked()
    {
        return isset($this->NonRevPassengersBooked) ? $this->NonRevPassengersBooked : null;
    }
    /**
     * Set NonRevPassengersBooked value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoPassengerCounts $nonRevPassengersBooked
     * @return \StructType\WBManifestInfoRS
     */
    public function setNonRevPassengersBooked(\StructType\WBManifestInfoPassengerCounts $nonRevPassengersBooked = null)
    {
        if (is_null($nonRevPassengersBooked) || (is_array($nonRevPassengersBooked) && empty($nonRevPassengersBooked))) {
            unset($this->NonRevPassengersBooked);
        } else {
            $this->NonRevPassengersBooked = $nonRevPassengersBooked;
        }
        return $this;
    }
    /**
     * Get NonRevPassengersCheckedIn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoPassengerCounts|null
     */
    public function getNonRevPassengersCheckedIn()
    {
        return isset($this->NonRevPassengersCheckedIn) ? $this->NonRevPassengersCheckedIn : null;
    }
    /**
     * Set NonRevPassengersCheckedIn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoPassengerCounts $nonRevPassengersCheckedIn
     * @return \StructType\WBManifestInfoRS
     */
    public function setNonRevPassengersCheckedIn(\StructType\WBManifestInfoPassengerCounts $nonRevPassengersCheckedIn = null)
    {
        if (is_null($nonRevPassengersCheckedIn) || (is_array($nonRevPassengersCheckedIn) && empty($nonRevPassengersCheckedIn))) {
            unset($this->NonRevPassengersCheckedIn);
        } else {
            $this->NonRevPassengersCheckedIn = $nonRevPassengersCheckedIn;
        }
        return $this;
    }
    /**
     * Get RevPassengersBoarded value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoPassengerCounts|null
     */
    public function getRevPassengersBoarded()
    {
        return isset($this->RevPassengersBoarded) ? $this->RevPassengersBoarded : null;
    }
    /**
     * Set RevPassengersBoarded value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoPassengerCounts $revPassengersBoarded
     * @return \StructType\WBManifestInfoRS
     */
    public function setRevPassengersBoarded(\StructType\WBManifestInfoPassengerCounts $revPassengersBoarded = null)
    {
        if (is_null($revPassengersBoarded) || (is_array($revPassengersBoarded) && empty($revPassengersBoarded))) {
            unset($this->RevPassengersBoarded);
        } else {
            $this->RevPassengersBoarded = $revPassengersBoarded;
        }
        return $this;
    }
    /**
     * Get RevPassengersBooked value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoPassengerCounts|null
     */
    public function getRevPassengersBooked()
    {
        return isset($this->RevPassengersBooked) ? $this->RevPassengersBooked : null;
    }
    /**
     * Set RevPassengersBooked value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoPassengerCounts $revPassengersBooked
     * @return \StructType\WBManifestInfoRS
     */
    public function setRevPassengersBooked(\StructType\WBManifestInfoPassengerCounts $revPassengersBooked = null)
    {
        if (is_null($revPassengersBooked) || (is_array($revPassengersBooked) && empty($revPassengersBooked))) {
            unset($this->RevPassengersBooked);
        } else {
            $this->RevPassengersBooked = $revPassengersBooked;
        }
        return $this;
    }
    /**
     * Get RevPassengersCheckedIn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WBManifestInfoPassengerCounts|null
     */
    public function getRevPassengersCheckedIn()
    {
        return isset($this->RevPassengersCheckedIn) ? $this->RevPassengersCheckedIn : null;
    }
    /**
     * Set RevPassengersCheckedIn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WBManifestInfoPassengerCounts $revPassengersCheckedIn
     * @return \StructType\WBManifestInfoRS
     */
    public function setRevPassengersCheckedIn(\StructType\WBManifestInfoPassengerCounts $revPassengersCheckedIn = null)
    {
        if (is_null($revPassengersCheckedIn) || (is_array($revPassengersCheckedIn) && empty($revPassengersCheckedIn))) {
            unset($this->RevPassengersCheckedIn);
        } else {
            $this->RevPassengersCheckedIn = $revPassengersCheckedIn;
        }
        return $this;
    }
    /**
     * Get TotalBagCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getTotalBagCount()
    {
        return isset($this->TotalBagCount) ? $this->TotalBagCount : null;
    }
    /**
     * Set TotalBagCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $totalBagCount
     * @return \StructType\WBManifestInfoRS
     */
    public function setTotalBagCount($totalBagCount = null)
    {
        // validation for constraint: int
        if (!is_null($totalBagCount) && !is_numeric($totalBagCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalBagCount)), __LINE__);
        }
        if (is_null($totalBagCount) || (is_array($totalBagCount) && empty($totalBagCount))) {
            unset($this->TotalBagCount);
        } else {
            $this->TotalBagCount = $totalBagCount;
        }
        return $this;
    }
    /**
     * Get TotalBagWeight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getTotalBagWeight()
    {
        return isset($this->TotalBagWeight) ? $this->TotalBagWeight : null;
    }
    /**
     * Set TotalBagWeight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $totalBagWeight
     * @return \StructType\WBManifestInfoRS
     */
    public function setTotalBagWeight($totalBagWeight = null)
    {
        if (is_null($totalBagWeight) || (is_array($totalBagWeight) && empty($totalBagWeight))) {
            unset($this->TotalBagWeight);
        } else {
            $this->TotalBagWeight = $totalBagWeight;
        }
        return $this;
    }
    /**
     * Get TotalPassengersBoarded value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getTotalPassengersBoarded()
    {
        return isset($this->TotalPassengersBoarded) ? $this->TotalPassengersBoarded : null;
    }
    /**
     * Set TotalPassengersBoarded value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $totalPassengersBoarded
     * @return \StructType\WBManifestInfoRS
     */
    public function setTotalPassengersBoarded($totalPassengersBoarded = null)
    {
        // validation for constraint: int
        if (!is_null($totalPassengersBoarded) && !is_numeric($totalPassengersBoarded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalPassengersBoarded)), __LINE__);
        }
        if (is_null($totalPassengersBoarded) || (is_array($totalPassengersBoarded) && empty($totalPassengersBoarded))) {
            unset($this->TotalPassengersBoarded);
        } else {
            $this->TotalPassengersBoarded = $totalPassengersBoarded;
        }
        return $this;
    }
    /**
     * Get TotalPassengersBooked value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getTotalPassengersBooked()
    {
        return isset($this->TotalPassengersBooked) ? $this->TotalPassengersBooked : null;
    }
    /**
     * Set TotalPassengersBooked value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $totalPassengersBooked
     * @return \StructType\WBManifestInfoRS
     */
    public function setTotalPassengersBooked($totalPassengersBooked = null)
    {
        // validation for constraint: int
        if (!is_null($totalPassengersBooked) && !is_numeric($totalPassengersBooked)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalPassengersBooked)), __LINE__);
        }
        if (is_null($totalPassengersBooked) || (is_array($totalPassengersBooked) && empty($totalPassengersBooked))) {
            unset($this->TotalPassengersBooked);
        } else {
            $this->TotalPassengersBooked = $totalPassengersBooked;
        }
        return $this;
    }
    /**
     * Get TotalPassengersCheckedIn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getTotalPassengersCheckedIn()
    {
        return isset($this->TotalPassengersCheckedIn) ? $this->TotalPassengersCheckedIn : null;
    }
    /**
     * Set TotalPassengersCheckedIn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $totalPassengersCheckedIn
     * @return \StructType\WBManifestInfoRS
     */
    public function setTotalPassengersCheckedIn($totalPassengersCheckedIn = null)
    {
        // validation for constraint: int
        if (!is_null($totalPassengersCheckedIn) && !is_numeric($totalPassengersCheckedIn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalPassengersCheckedIn)), __LINE__);
        }
        if (is_null($totalPassengersCheckedIn) || (is_array($totalPassengersCheckedIn) && empty($totalPassengersCheckedIn))) {
            unset($this->TotalPassengersCheckedIn);
        } else {
            $this->TotalPassengersCheckedIn = $totalPassengersCheckedIn;
        }
        return $this;
    }
    /**
     * Get TotalSeatCapacity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getTotalSeatCapacity()
    {
        return isset($this->TotalSeatCapacity) ? $this->TotalSeatCapacity : null;
    }
    /**
     * Set TotalSeatCapacity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $totalSeatCapacity
     * @return \StructType\WBManifestInfoRS
     */
    public function setTotalSeatCapacity($totalSeatCapacity = null)
    {
        // validation for constraint: int
        if (!is_null($totalSeatCapacity) && !is_numeric($totalSeatCapacity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalSeatCapacity)), __LINE__);
        }
        if (is_null($totalSeatCapacity) || (is_array($totalSeatCapacity) && empty($totalSeatCapacity))) {
            unset($this->TotalSeatCapacity);
        } else {
            $this->TotalSeatCapacity = $totalSeatCapacity;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WBManifestInfoRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
